<?php
class setLeginonDefaultValues {
	
	var $userId;
	var $sessionId;
	var $mysqld;	// make sure this is using the leginon database
	
	function setLeginonDefaultValues($mysqld, $userId=null){
		
		$this->mysqld = $mysqld;
		
		if($userId == null){
			$this->userId = $this->setUserId();
		}
		else
			$this->userId = $userId;
		$this->sessionId = $this->createNewSession();
		$this->addDefaultValues();
	}

	function getUserId(){
		return $this->userID;
	}
	
	function setUserId(){
		$sql = 'SELECT `DEF_id` from `UserData` where `username` like "administrator" or "Administrator"';
		$results = $this->mysqld->getSQLResult($sql);
		$userId = $results[0]['DEF_id'];

		if($userId < 1){
			echo "<h3> Error: Create administrator user first </h3>";
			exit();
		}		
		return $userId;
	}
	
	function createNewSession(){
		$sql = "insert into `SessionData` (`name`,`REF|UserData|user`,`comment`, `hidden` ) "
      		. " VALUES "
      		. " ( concat('importsettings', DATE_FORMAT(now(), '%Y%m%d%H%i%s')), "
			. " ".$this->userId." ,'import default',1) ";
		return $this->mysqld->SQLQuery($sql, true);
	}
	
	function addDefaultValues(){
		$table = "BeamTiltCalibratorSettingsData";
		$data=array();
		$data["name"] = "Beam Tilt";
		$data["isdefault"] = "1";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["defocus beam tilt"] = "0.01";
		$data["first defocus"] = "-2e-06";
		$data["second defocus"] = "-4e-06";
		$data["stig beam tilt"] = "0.01";
		$data["stig delta"] = "0.2";
		$data["measure beam tilt"] = "0.01";
		$data["correct tilt"] = "1";
		$data["settling time"] = "0.5";
		$data["comafree beam tilt"] = "0.005";
		$data["comafree misalign"] = "0.002";
		$data["imageshift coma tilt"] = "0.005";
		$data["imageshift coma step"] = "-1e-06";
		$data["imageshift coma number"] = "1";
		$data["imageshift coma repeat"] = "1";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["REF|SessionData|session"]= $this->sessionId;
		$bid19=$this->mysqld->SQLInsert($table, $data);

		$table = "MatrixCalibratorSettingsData";
		$data=array();
		$data["name"] = "Matrix";
		$data["isdefault"] = "1";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["image shift tolerance"] = "12";
		$data["image shift shift fraction"] = "25";
		$data["image shift n average"] = "1";
		$data["image shift interval"] = "2e-06";
		$data["image shift current as base"] = "1";
		$data["SUBD|image shift base|x"] = "0";
		$data["SUBD|image shift base|y"] = "0";
		$data["beam shift tolerance"] = "12";
		$data["beam shift shift fraction"] = "25";
		$data["beam shift n average"] = "1";
		$data["beam shift interval"] = "2e-06";
		$data["beam shift current as base"] = "1";
		$data["SUBD|beam shift base|x"] = "0";
		$data["SUBD|beam shift base|y"] = "0";
		$data["stage position tolerance"] = "12";
		$data["stage position shift fraction"] = "25";
		$data["stage position n average"] = "1";
		$data["stage position interval"] = "2e-06";
		$data["stage position current as base"] = "1";
		$data["SUBD|stage position base|x"] = "0";
		$data["SUBD|stage position base|y"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid6=$this->mysqld->SQLInsert($table, $data);

		$table = "MatrixCalibratorSettingsData";
		$data=array();
		$data["name"] = "Matrix Calibrator";
		$data["isdefault"] = "1";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["image shift tolerance"] = "12";
		$data["image shift shift fraction"] = "25";
		$data["image shift n average"] = "1";
		$data["image shift interval"] = "2e-06";
		$data["image shift current as base"] = "1";
		$data["SUBD|image shift base|x"] = "0";
		$data["SUBD|image shift base|y"] = "0";
		$data["beam shift tolerance"] = "12";
		$data["beam shift shift fraction"] = "25";
		$data["beam shift n average"] = "1";
		$data["beam shift interval"] = "2e-06";
		$data["beam shift current as base"] = "1";
		$data["SUBD|beam shift base|x"] = "0";
		$data["SUBD|beam shift base|y"] = "0";
		$data["stage position tolerance"] = "12";
		$data["stage position shift fraction"] = "25";
		$data["stage position n average"] = "1";
		$data["stage position interval"] = "2e-06";
		$data["stage position current as base"] = "1";
		$data["SUBD|stage position base|x"] = "0";
		$data["SUBD|stage position base|y"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid8=$this->mysqld->SQLInsert($table, $data);

		$table = "PixelSizeCalibratorSettingsData";
		$data=array();
		$data["name"] = "Pixel Size";
		$data["isdefault"] = "1";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["lattice a"] = "69";
		$data["lattice b"] = "173.5";
		$data["lattice gamma"] = "90";
		$data["h1"] = "0";
		$data["k1"] = "6";
		$data["h2"] = "0";
		$data["k2"] = "-6";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["REF|SessionData|session"]= $this->sessionId;
		$pid6=$this->mysqld->SQLInsert($table, $data);

		$table = "DoseCalibratorSettingsData";
		$data=array();
		$data["name"] = "Dose";
		$data["isdefault"] = "1";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["beam diameter"] = "0.16";
		$data["scale factor"] = "0.88";
		$data["REF|SessionData|session"]= $this->sessionId;
		$did6=$this->mysqld->SQLInsert($table, $data);

		$table = "PresetsManagerSettingsData";
		$data=array();
		$data["stage always"] = "1";
		$data["name"] = "Presets Manager";
		$data["xy only"] = "1";
		$data["pause time"] = "1";
		$data["optimize cycle"] = "1";
		$data["mag only"] = "0";
		$data["cycle"] = "1";
		$data["isdefault"] = "1";
		$data["apply offset"] = "0";
		$data["smallsize"] = "1024";
		$data["blank"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$pid2174=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'gr']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "1.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Grid";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$aid46=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'sq']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "1.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Square";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid47=$this->mysqld->SQLInsert($table, $data);
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'rsq']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "1.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "RCT Square";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid47=$this->mysqld->SQLInsert($table, $data);

		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "1.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Hole";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid49=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Preview";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "1e-06";
		$data["process target type"] = "preview";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid61=$this->mysqld->SQLInsert($table, $data);

		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'en']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "image shift";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Exposure";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["use parent mover"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid53=$this->mysqld->SQLInsert($table, $data);

		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'sq']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Square Q";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid65=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Hole Q";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid67=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'preview']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Tomography Preview";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "preview";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$aid69=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Final Section";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "1";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid99=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Subsquare";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid71=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'sq']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Centered Square";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid59=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'sq']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Rough Tissue";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid55=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Final Raster";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "1";
		$data["use parent tilt"] = "1";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "1";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid73=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'gr']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Grid Survey";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid80=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Mid Mag Survey";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid82=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'sq']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "1";
		$data["name"] = "Reacquisition";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid86=$this->mysqld->SQLInsert($table, $data);
		
		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'en']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "High Mag Acquisition";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid84=$this->mysqld->SQLInsert($table, $data);

		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'en']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Exposure MultiMove";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "navigator";
		$data["move precision"] = "1e-07";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "5e-07";
		$data["wait for reference"] = "1";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid191=$this->mysqld->SQLInsert($table, $data);

		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "1";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "1.5";
		$data["melt time"] = "0";
		$data["name"] = "Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "image shift";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid14=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Z Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "hl";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid12=$this->mysqld->SQLInsert($table, $data);

		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Tomo Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid24=$this->mysqld->SQLInsert($table, $data);

		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Tomo Z Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid22=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Cal Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid24=$this->mysqld->SQLInsert($table, $data);

		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "1";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "RCT Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid20=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Section Z Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "hl";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid32=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'gr']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Grid Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "gr";
		$data["manual focus preset"] = "gr";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid16=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Section Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "hl";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid18=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Screen Z Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "fc";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid26=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Z Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "focus";
		$data["melt preset"] = "hl";
		$data["manual focus preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid27=$this->mysqld->SQLInsert($table, $data);

		$table = "MosaicTargetMakerSettingsData";
		$data=array();
		$data["max targets"] = "128";
		$data["name"] = "Grid Targeting";
		$data["max size"] = "16384";
		$data["overlap"] = "1";
		$data["radius"] = "0.0009";
		$data["preset"] = "gr";
		$data["mosaic center"] = "stage center";
		$data["isdefault"] = "1";
		$data["ignore request"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid14=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicTargetMakerSettingsData";
		$data=array();
		$data["max targets"] = "128";
		$data["name"] = "Grid Targeting Robot";
		$data["max size"] = "16384";
		$data["overlap"] = "1";
		$data["radius"] = "0.0005";
		$data["preset"] = "gr";
		$data["mosaic center"] = "stage center";
		$data["isdefault"] = "1";
		$data["ignore request"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid13=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicTargetMakerSettingsData";
		$data=array();
		$data["max targets"] = "128";
		$data["name"] = "Grid Survey Targeting";
		$data["max size"] = "16384";
		$data["overlap"] = "1";
		$data["radius"] = "0.0005";
		$data["preset"] = "gr";
		$data["mosaic center"] = "stage center";
		$data["isdefault"] = "1";
		$data["ignore request"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid16=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["on"] = "0";
		$data["sigma"] = "1.4";
		$data["size"] = "5";
		$lid10=$this->mysqld->SQLInsert($table, $data);
		
		$table = "BlobFinderSettingsData";
		$data=array();
		$data["max"] = "100";
		$data["min size"] = "10";
		$data["max size"] = "10000";
		$data["min mean"] = "1000";
		$data["min stdev"] = "10";
		$data["border"] = "0";
		$data["max mean"] = "20000";
		$data["max stdev"] = "500";
		$data["isdefault"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$bid6=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicClickTargetFinderSettingsData";
		$data=array();
		$data["REF|BlobFinderSettingsData|blobs"] = $bid6;
		$data["no resubmit"] = "0";
		$data["name"] = "Square Targeting";
		$data["scale image"] = "1";
		$data["wait for done"] = "0";
		$data["calibration parameter"] = "stage position";
		$data["scale size"] = "512";
		$data["threshold"] = "100";
		$data["REF|LowPassFilterSettingsData|lpf"] = $lid10;
		$data["ignore images"] = "0";
		$data["queue"] = "0";
		$data["user check"] = "0";
		$data["queue drift"] = "0";
		$data["isdefault"] = "1";
		$data["create on tile change"] = "all";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid19=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicClickTargetFinderSettingsData";
		$data=array();
		$data["no resubmit"] = "0";
		$data["name"] = "Raster Center Targeting";
		$data["scale image"] = "1";
		$data["wait for done"] = "0";
		$data["calibration parameter"] = "stage position";
		$data["scale size"] = "512";
		$data["threshold"] = "100";
		$data["ignore images"] = "0";
		$data["queue"] = "0";
		$data["user check"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["create on tile change"] = "all";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["on"] = "1";
		$data["sigma"] = "1.4";
		$data["size"] = "5";
		$lid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicClickTargetFinderSettingsData";
		$data=array();
		$data["no resubmit"] = "0";
		$data["name"] = "Rough Tissue Targeting";
		$data["scale image"] = "1";
		$data["wait for done"] = "0";
		$data["calibration parameter"] = "stage position";
		$data["scale size"] = "512";
		$data["threshold"] = "100";
		$data["REF|LowPassFilterSettingsData|lpf"] = $lid2;
		$data["ignore images"] = "0";
		$data["queue"] = "0";
		$data["user check"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["create on tile change"] = "all";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid3=$this->mysqld->SQLInsert($table, $data);
		
		$table = "MosaicClickTargetFinderSettingsData";
		$data=array();
		$data["REF|BlobFinderSettingsData|blobs"] = $bid6;
		$data["no resubmit"] = "0";
		$data["name"] = "Atlas View";
		$data["scale image"] = "1";
		$data["wait for done"] = "0";
		$data["calibration parameter"] = "stage position";
		$data["scale size"] = "512";
		$data["threshold"] = "100";
		$data["REF|LowPassFilterSettingsData|lpf"] = $lid10;
		$data["ignore images"] = "0";
		$data["queue"] = "0";
		$data["user check"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["create on tile change"] = "all";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$mid7=$this->mysqld->SQLInsert($table, $data);
		
		$table = "ClickTargetFinderSettingsData";
		$data=array();
		$data["wait for done"] = "1";
		$data["ignore images"] = "0";
		$data["no resubmit"] = "0";
		$data["name"] = "Hole Targeting";
		$data["queue"] = "1";
		$data["user check"] = "1";
		$data["isdefault"] = "1";
		$data["queue drift"] = "1";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$cid1=$this->mysqld->SQLInsert($table, $data);
		
		$table = "ClickTargetFinderSettingsData";
		$data=array();
		$data["wait for done"] = "1";
		$data["ignore images"] = "0";
		$data["no resubmit"] = "0";
		$data["name"] = "Tomography Targeting";
		$data["queue"] = "1";
		$data["user check"] = "1";
		$data["isdefault"] = "1";
		$data["queue drift"] = "1";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$cid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["sigma"] = "1";
		$lid11=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["on"] = "0";
		$data["sigma"] = "1";
		$data["size"] = "0";
		$lid6=$this->mysqld->SQLInsert($table, $data);
		
		$table = "HoleFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.2";
		$data["blobs max"] = "300";
		$data["lattice spacing"] = "102";
		$data["focus template thickness"] = "0";
		$data["skip"] = "0";
		$data["edge threshold"] = "4000";
		$data["threshold"] = "240";
		$data["SEQ|focus template"] = "[(0, 0)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "0";
		$data["ignore images"] = "0";
		$data["REF|LowPassFilterSettingsData|template lpf"] = $lid6;
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.28";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["template type"] = "cross";
		$data["lattice hole radius"] = "15";
		$data["focus stats radius"] = "10";
		$data["focus hole"] = "Good Hole";
		$data["SEQ|acquisition template"] = "[(0, 0)]";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["blobs border"] = "20";
		$data["SEQ|template rings"] = "[(35, 41)]";
		$data["ice max mean"] = "0.3";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid11;
		$data["name"] = "Hole Targeting";
		$data["focus max mean thickness"] = "0.5";
		$data["ice max std"] = "0.2";
		$data["lattice zero thickness"] = "52000";
		$data["blobs max size"] = "200";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.5";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["blobs min size"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$hid21=$this->mysqld->SQLInsert($table, $data);


		$table = "HoleFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.1";
		$data["blobs max"] = "1";
		$data["lattice spacing"] = "150";
		$data["focus template thickness"] = "1";
		$data["skip"] = "0";
		$data["edge threshold"] = "6000";
		$data["threshold"] = "0.01";
		$data["SEQ|focus template"] = "[(220, 0), (150, 150), (0, 220), (-150, 150), (-220, 0), (-150, -150), (0, -220), (150, -150)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "1";
		$data["ignore images"] = "0";
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.01";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["template type"] = "phase";
		$data["lattice hole radius"] = "15";
		$data["focus stats radius"] = "100";
		$data["focus hole"] = "Off";
		$data["SEQ|acquisition template"] = "[(0, 0)]";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["blobs border"] = "20";
		$data["SEQ|template rings"] = "[(160, 170)]";
		$data["ice max mean"] = "0.2";
		$data["name"] = "Exposure Targeting";
		$data["focus max mean thickness"] = "0.5";
		$data["ice max std"] = "0.2";
		$data["lattice zero thickness"] = "26000";
		$data["blobs max size"] = "1000";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.5";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["blobs min size"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$hid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["on"] = "1";
		$data["sigma"] = "1";
		$data["size"] = "5";
		$lid4=$this->mysqld->SQLInsert($table, $data);


		$table = "JAHCFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.2";
		$data["blobs max"] = "300";
		$data["blobs border"] = "20";
		$data["lattice spacing"] = "77";
		$data["focus template thickness"] = "0";
		$data["skip"] = "0";
		$data["edge threshold"] = "100";
		$data["threshold"] = "3";
		$data["SEQ|focus template"] = "[(0, 0)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "0";
		$data["queue drift"] = "1";
		$data["ignore images"] = "0";
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.05";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["isdefault"] = "1";
		$data["template type"] = "cross";
		$data["lattice hole radius"] = "15";
		$data["focus stats radius"] = "10";
		$data["focus hole"] = "Any Hole";
		$data["SEQ|acquisition template"] = "[(0, 0)]";
		$data["template diameter"] = "45";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["file diameter"] = "168";
		$data["ice max mean"] = "0.16";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid4;
		$data["name"] = "Hole Targeting";
		$data["focus max mean thickness"] = "0.5";
		$data["ice max std"] = "0.15";
		$data["lattice zero thickness"] = "140";
		$data["blobs max size"] = "1000";
		$data["queue"] = "0";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.5";
		$data["threshold method"] = "Threshold = mean + A * stdev";
		$data["sort target"] = "0";
		$data["blobs min size"] = "10";
		$data["allow append"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$jid1=$this->mysqld->SQLInsert($table, $data);
		
		$table = "LowPassFilterSettingsData";
		$data=array();
		$data["on"] = "0";
		$data["sigma"] = "1";
		$data["size"] = "0";
		$lid9=$this->mysqld->SQLInsert($table, $data);
		
		$table = "JAHCFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.1";
		$data["blobs max"] = "1";
		$data["blobs border"] = "20";
		$data["lattice spacing"] = "150";
		$data["focus template thickness"] = "1";
		$data["skip"] = "0";
		$data["edge threshold"] = "100";
		$data["threshold"] = "0.0009";
		$data["SEQ|focus template"] = "[(-12, -144), (-144, 12), (12, 144), (144, -12)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "1";
		$data["queue drift"] = "1";
		$data["ignore images"] = "0";
		$data["REF|LowPassFilterSettingsData|template lpf"] = $lid9;
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.05";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["isdefault"] = "1";
		$data["template type"] = "phase";
		$data["lattice hole radius"] = "35";
		$data["focus stats radius"] = "50";
		$data["focus hole"] = "Off";
		$data["SEQ|acquisition template"] = "[(0, 35), (0, -35)]";
		$data["template diameter"] = "115";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["file diameter"] = "168";
		$data["ice max mean"] = "5";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid9;
		$data["name"] = "Exposure Targeting Q";
		$data["focus max mean thickness"] = "4";
		$data["ice max std"] = "0.5";
		$data["lattice zero thickness"] = "115";
		$data["blobs max size"] = "10000";
		$data["queue"] = "1";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.1";
		$data["threshold method"] = "Threshold = A";
		$data["sort target"] = "0";
		$data["blobs min size"] = "10";
		$data["allow append"] = "0";
		$data["lattice extend"] = "off";
		$data["REF|SessionData|session"]= $this->sessionId;
		$jid72=$this->mysqld->SQLInsert($table, $data);

		$table = "JAHCFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.1";
		$data["blobs max"] = "1";
		$data["blobs border"] = "20";
		$data["lattice spacing"] = "150";
		$data["focus template thickness"] = "1";
		$data["skip"] = "0";
		$data["edge threshold"] = "100";
		$data["threshold"] = "0.0009";
		$data["SEQ|focus template"] = "[(-12, -144), (-144, 12), (12, 144), (144, -12)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "1";
		$data["queue drift"] = "1";
		$data["ignore images"] = "0";
		$data["REF|LowPassFilterSettingsData|template lpf"] = $lid9;
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.05";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["isdefault"] = "1";
		$data["template type"] = "phase";
		$data["lattice hole radius"] = "35";
		$data["focus stats radius"] = "50";
		$data["focus hole"] = "Off";
		$data["SEQ|acquisition template"] = "[(0, 35), (0, -35)]";
		$data["template diameter"] = "115";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["file diameter"] = "168";
		$data["ice max mean"] = "5";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid9;
		$data["name"] = "Exposure Targeting";
		$data["focus max mean thickness"] = "4";
		$data["ice max std"] = "0.5";
		$data["lattice zero thickness"] = "115";
		$data["blobs max size"] = "10000";
		$data["queue"] = "0";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.1";
		$data["threshold method"] = "Threshold = A";
		$data["sort target"] = "0";
		$data["blobs min size"] = "10";
		$data["allow append"] = "0";
		$data["lattice extend"] = "off";
		$data["REF|SessionData|session"]= $this->sessionId;
		$jid20=$this->mysqld->SQLInsert($table, $data);

		$table = "JAHCFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.1";
		$data["blobs max"] = "1";
		$data["blobs border"] = "20";
		$data["lattice spacing"] = "150";
		$data["focus template thickness"] = "1";
		$data["skip"] = "1";
		$data["edge threshold"] = "100";
		$data["threshold"] = "1.5";
		$data["SEQ|focus template"] = "[(22, 128), (128, -22), (-22, -128), (-128, 22)]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "1";
		$data["queue drift"] = "1";
		$data["ignore images"] = "0";
		$data["REF|LowPassFilterSettingsData|template lpf"] = $lid6;
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.05";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["isdefault"] = "1";
		$data["template type"] = "cross";
		$data["lattice hole radius"] = "30";
		$data["focus stats radius"] = "100";
		$data["focus hole"] = "Off";
		$data["SEQ|acquisition template"] = "[(0, -35), (0, 35)]";
		$data["template diameter"] = "140";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.1";
		$data["file diameter"] = "168";
		$data["ice max mean"] = "0.2";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid6;
		$data["name"] = "RCT Targeting";
		$data["focus max mean thickness"] = "0.3";
		$data["ice max std"] = "0.2";
		$data["lattice zero thickness"] = "110";
		$data["blobs max size"] = "1000";
		$data["queue"] = "1";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.1";
		$data["threshold method"] = "Threshold = mean + A * stdev";
		$data["sort target"] = "0";
		$data["blobs min size"] = "10";
		$data["allow append"] = "0";
		$data["lattice extend"] = "off";
		$data["REF|SessionData|session"]= $this->sessionId;
		$jid21=$this->mysqld->SQLInsert($table, $data);
		
		$table = "JAHCFinderSettingsData";
		$data=array();
		$data["lattice tolerance"] = "0.1";
		$data["blobs max"] = "300";
		$data["blobs border"] = "20";
		$data["lattice spacing"] = "110";
		$data["focus template thickness"] = "0";
		$data["skip"] = "0";
		$data["edge threshold"] = "100";
		$data["threshold"] = "2";
		$data["SEQ|focus template"] = "[]";
		$data["edge log sigma"] = "1.4";
		$data["target template"] = "0";
		$data["queue drift"] = "1";
		$data["ignore images"] = "0";
		$data["REF|LowPassFilterSettingsData|template lpf"] = $lid6;
		$data["edge absolute"] = "0";
		$data["ice min mean"] = "0.15";
		$data["edge log size"] = "9";
		$data["wait for done"] = "1";
		$data["isdefault"] = "1";
		$data["template type"] = "cross";
		$data["lattice hole radius"] = "30";
		$data["focus stats radius"] = "10";
		$data["focus hole"] = "Off";
		$data["SEQ|acquisition template"] = "[]";
		$data["template diameter"] = "90";
		$data["user check"] = "1";
		$data["edge type"] = "sobel";
		$data["focus min mean thickness"] = "0.05";
		$data["file diameter"] = "168";
		$data["ice max mean"] = "0.35";
		$data["REF|LowPassFilterSettingsData|edge lpf"] = $lid6;
		$data["name"] = "Square Targeting";
		$data["focus max mean thickness"] = "0.5";
		$data["ice max std"] = "0.3";
		$data["lattice zero thickness"] = "200";
		$data["blobs max size"] = "1000";
		$data["queue"] = "0";
		$data["edge"] = "1";
		$data["focus max stdev thickness"] = "0.5";
		$data["threshold method"] = "Threshold = mean + A * stdev";
		$data["sort target"] = "0";
		$data["blobs min size"] = "10";
		$data["allow append"] = "0";
		$data["lattice extend"] = "off";
		$data["REF|SessionData|session"]= $this->sessionId;
		$jid23=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "9";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[(550, 512)]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "0";
		$data["ice max mean"] = "0.3";
		$data["name"] = "Subsquare Targeting";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "1";
		$data["ice thickness"] = "140";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "50";
		$data["SEQ|acquisition convolve template"] = "[(0, 0)]";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "-103.37793736856";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "50";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "hl";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "0";
		$data["allow append"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid1=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "5";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[(256, 200)]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "0";
		$data["ice max mean"] = "0.2";
		$data["name"] = "Exposure Targeting";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "1";
		$data["ice thickness"] = "110";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "100";
		$data["SEQ|acquisition convolve template"] = "[(0, 0)]";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "0";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "0";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "gr";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "0";
		$data["allow append"] = "0";
		$data["ice min std"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid11=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "1";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "1";
		$data["ice max mean"] = "0.2";
		$data["name"] = "Square Centering";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "1";
		$data["ice thickness"] = "1000";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[(0, 0)]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "100";
		$data["SEQ|acquisition convolve template"] = "[(0, 0)]";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "0";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "0";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "en";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "1";
		$data["allow append"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid3=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "5";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[(256, 240)]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "0";
		$data["ice max mean"] = "0.2";
		$data["name"] = "RCT Targeting";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "1";
		$data["ice thickness"] = "110";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "100";
		$data["SEQ|acquisition convolve template"] = "[(0, 0)]";
		$data["queue"] = "1";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "0";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "0";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "en";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "0";
		$data["allow append"] = "0";
		$data["ice min std"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid19=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "2";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "0";
		$data["ice max mean"] = "0.5";
		$data["name"] = "Mid Mag Survey Targeting";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "0";
		$data["ice thickness"] = "100";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "100";
		$data["SEQ|acquisition convolve template"] = "[]";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "0";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "0";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "hl";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "0";
		$data["allow append"] = "0";
		$data["ice min std"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid7=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterFinderSettingsData";
		$data=array();
		$data["raster limit"] = "3";
		$data["SEQ|acquisition constant template"] = "[]";
		$data["SEQ|focus constant template"] = "[(256, 256)]";
		$data["ice box size"] = "15";
		$data["user check"] = "1";
		$data["focus convolve"] = "0";
		$data["ice max mean"] = "0.2";
		$data["name"] = "High Mag Raster Targeting";
		$data["ignore images"] = "0";
		$data["acquisition convolve"] = "0";
		$data["ice thickness"] = "1000";
		$data["ice max std"] = "0.2";
		$data["SEQ|focus convolve template"] = "[]";
		$data["ice min mean"] = "0.05";
		$data["wait for done"] = "1";
		$data["raster spacing"] = "100";
		$data["SEQ|acquisition convolve template"] = "[]";
		$data["queue"] = "0";
		$data["queue drift"] = "1";
		$data["isdefault"] = "1";
		$data["raster center on image"] = "1";
		$data["raster angle"] = "0";
		$data["raster center x"] = "0";
		$data["raster center y"] = "0";
		$data["select polygon"] = "0";
		$data["publish polygon"] = "0";
		$data["raster spacing asymm"] = "0";
		$data["raster limit asymm"] = "0";
		$data["raster symmetric"] = "1";
		$data["sort target"] = "0";
		$data["raster preset"] = "gr";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["skip"] = "0";
		$data["allow append"] = "0";
		$data["ice min std"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid9=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterTargetFilterSettingsData";
		$data=array();
		$data["name"] = "Raster Generation";
		$data["isdefault"] = "1";
		$data["bypass"] = "0";
		$data["raster spacing"] = "20";
		$data["raster angle"] = "0";
		$data["raster preset"] = "hl";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["target type"] = "acquisition";
		$data["ellipse angle"] = "0";
		$data["ellipse a"] = "2";
		$data["ellipse b"] = "2";
		$data["user check"] = "1";
		$data["raster offset"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid9=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RasterTargetFilterSettingsData";
		$data=array();
		$data["name"] = "Final Raster Targeting";
		$data["isdefault"] = "1";
		$data["bypass"] = "0";
		$data["raster spacing"] = "50";
		$data["raster angle"] = "0";
		$data["raster preset"] = "hl";
		$data["raster movetype"] = "stage position";
		$data["raster overlap"] = "0";
		$data["target type"] = "acquisition";
		$data["ellipse angle"] = "0";
		$data["ellipse a"] = "2";
		$data["ellipse b"] = "2";
		$data["user check"] = "1";
		$data["raster offset"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid3=$this->mysqld->SQLInsert($table, $data);
		
		$table = "CenterTargetFilterSettingsData";
		$data=array();
		$data["name"] = "Square Target Filtering";
		$data["isdefault"] = "1";
		$data["bypass"] = "0";
		$data["limit"] = "1";
		$data["target type"] = "acquisition";
		$data["user check"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$cid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "TomographySettingsData";
		$data=array();
		$data["display image"] = "1";
		$data["wait time"] = "0";
		$data["SEQ|preset order"] = "[u'tomo']";
		$data["tilt max"] = "60";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["tilt min"] = "-60";
		$data["run buffer cycle"] = "0";
		$data["correct image"] = "1";
		$data["move type"] = "stage position";
		$data["wait for rejects"] = "1";
		$data["name"] = "Tomography";
		$data["align zero loss peak"] = "0";
		$data["xcf bin"] = "1";
		$data["wait for process"] = "0";
		$data["tilt start"] = "0";
		$data["tilt step"] = "1";
		$data["dose"] = "200";
		$data["min exposure"] = "0.025";
		$data["max exposure"] = "2";
		$data["process target type"] = "acquisition";
		$data["mover"] = "navigator";
		$data["move precision"] = "6e-08";
		$data["equally sloped"] = "0";
		$data["equally sloped n"] = "8";
		$data["measure dose"] = "1";
		$data["mean threshold"] = "100";
		$data["collection threshold"] = "90";
		$data["tilt pause time"] = "1";
		$data["measure defocus"] = "0";
		$data["integer"] = "1";
		$data["intscale"] = "1";
		$data["save integer"] = "0";
		$data["model mag"] = "custom values";
		$data["z0 error"] = "2e-06";
		$data["phi"] = "0";
		$data["offset"] = "0";
		$data["fixed model"] = "1";
		$data["offset2"] = "0";
		$data["phi2"] = "0";
		$data["use lpf"] = "0";
		$data["drift between"] = "1";
		$data["final image shift"] = "1";
		$data["accept precision"] = "2e-07";
		$data["use tilt"] = "1";
		$data["fit data points"] = "4";
		$data["taper size"] = "10";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["z0"] = "0";
		$data["use z0"] = "0";
		$data["tilt order"] = "sequential";
		$data["use preset exposure"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$tid11=$this->mysqld->SQLInsert($table, $data);
		
		$table = "RCTAcquisitionSettingsData";
		$data=array();
		$data["wait time"] = "0";
		$data["SEQ|preset order"] = "[u'en']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["name"] = "RCT";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "1";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["minsize"] = "50";
		$data["maxsize"] = "0.8";
		$data["stepsize"] = "15";
		$data["tilts"] = "(-45, 0)";
		$data["process target type"] = "acquisition";
		$data["mover"] = "navigator";
		$data["move precision"] = "6e-08";
		$data["drift threshold"] = "6e-10";
		$data["drift preset"] = "fa";
		$data["save integer"] = "0";
		$data["pause"] = "1";
		$data["medfilt"] = "2";
		$data["lowfilt"] = "1";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "5e-07";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$rid4=$this->mysqld->SQLInsert($table, $data);
		
		$table = "DTFinderSettingsData";
		$data=array();
		$data["name"] = "Tissue Centering";
		$data["isdefault"] = "1";
		$data["wait for done"] = "1";
		$data["ignore images"] = "0";
		$data["queue"] = "1";
		$data["user check"] = "1";
		$data["queue drift"] = "1";
		$data["sort target"] = "0";
		$data["allow append"] = "0";
		$data["skip"] = "1";
		$data["template size"] = "100";
		$data["correlation lpf"] = "1.3";
		$data["correlation type"] = "phase";
		$data["angle increment"] = "5";
		$data["rotate"] = "0";
		$data["snr threshold"] = "6";
		$data["REF|SessionData|session"]= $this->sessionId;
		$did18=$this->mysqld->SQLInsert($table, $data);
		
		$table = "CorrectorSettingsData";
		$data=array();
		$data["name"] = "Correction";
		$data["despike size"] = "11";
		$data["despike threshold"] = "3.5";
		$data["despike"] = "0";
		$data["n average"] = "3";
		$data["REF|CameraSettingsData|camera settings"] = "2";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["isdefault"] = "1";
		$data["combine"] = "average";
		$data["clip min"] = "0";
		$data["clip max"] = "65536";
		$data["REF|SessionData|session"]= $this->sessionId;
		$cid30=$this->mysqld->SQLInsert($table, $data);
		
		$table = "BeamFixerSettingsData";
		$data=array();
		$data["name"] = "Fix Beam";
		$data["isdefault"] = "1";
		$data["move type"] = "stage position";
		$data["pause time"] = "3";
		$data["interval time"] = "3600";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "3";
		$data["SUBD|instruments|ccdcamera"] = "None";
		$data["SUBD|instruments|tem"] = "None";
		$data["SEQ|correction presets"] = "[u'fc', u'fa', u'en', u'ef']";
		$data["shift step"] = "25";
		$data["SUBD|stage position|x"] = "0";
		$data["SUBD|stage position|y"] = "0";
		$data["SUBD|stage position|z"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$bid4=$this->mysqld->SQLInsert($table, $data);
		
		$table = "GonModelerSettingsData";
		$data=array();
		$data["name"] = "GonioModeling";
		$data["isdefault"] = "1";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["correlation type"] = "phase";
		$data["lpf sigma"] = "1.0";
		$data["measure axis"] = "x";
		$data["measure points"] = "5";
		$data["measure interval"] = "5e-06";
		$data["measure tolerance"] = "25";
		$data["model axis"] = "x";
		$data["model terms"] = "0";
		$data["model mag only"] = "0";
		$data["model tolerance"] = "25";
		$data["REF|SessionData|session"]= $this->sessionId;
		$gid4=$this->mysqld->SQLInsert($table, $data);
		
		$table = "BeamTiltImagerSettingsData";
		$data=array();
		$data["name"] = "Beam Tilt Image";
		$data["isdefault"] = "1";
		$data["process target type"] = "acquisition";
		$data["pause time"] = "2.5";
		$data["move type"] = "image shift";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["correct image"] = "1";
		$data["display image"] = "1";
		$data["save image"] = "1";
		$data["wait for process"] = "0";
		$data["wait for rejects"] = "0";
		$data["wait for reference"] = "0";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["adjust for transform"] = "no";
		$data["drift between"] = "0";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["accept precision"] = "0.001";
		$data["save integer"] = "0";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["park after target"] = "0";
		$data["beam tilt"] = "0.005";
		$data["beam tilt count"] = "1";
		$data["sites"] = "4";
		$data["startangle"] = "0";
		$data["tableau type"] = "beam tilt series-power";
		$data["tableau binning"] = "2";
		$data["tableau split"] = "8";
		$data["correlation type"] = "phase";
		$data["REF|SessionData|session"]= $this->sessionId;
		$bid8=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Focus";
		$data["SEQ|sequence"] = "['Defocus1', 'Defocus2', 'Manual_after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid1=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Z_to_Eucentric";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid25=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "1";
		$data["preset name"] = "fa";
		$data["name"] = "Defocus1";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid26=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Defocus2";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid26=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual_after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid27=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Z Focus";
		$data["SEQ|sequence"] = "[u'Stage_Tilt_Rough', u'Stage_Tilt_Fine', 'Manual_after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid2=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "sq";
		$data["name"] = "Stage_Tilt_Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.017453292519943295";
		$data["node name"] = "Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0002";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid28=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.017453292519943295";
		$data["node name"] = "Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0002";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid29=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "10000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual_after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid30=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Tomo Focus";
		$data["SEQ|sequence"] = "[u'Stage_Tilt_Fine1', 'Stage_Tilt_Fine2', 'Beam_Tilt_Fine', 'Manual_after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid3=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine1";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Tomo Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid7=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine2";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Tomo Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "5e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid8=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "1";
		$data["preset name"] = "fa";
		$data["name"] = "Beam_Tilt_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Tomo Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "5e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid9=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual_after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Tomo Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid10=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Tomo Z Focus";
		$data["SEQ|sequence"] = "[u'Stage_Tilt_Rough', 'Stage_Tilt_Fine', 'Beam_Tilt_Auto', 'Manual_after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid4=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "sq";
		$data["name"] = "Stage_Tilt_Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Tomo Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0002";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid11=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Tomo Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid12=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Beam_Tilt_Auto";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Tomo Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "5e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid13=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual_after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Tomo Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid14=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Cal Focus";
		$data["SEQ|sequence"] = "[u'Stage_Tilt_Rough', 'Stage_Tilt_Fine', 'Beam_Tilt_Auto', 'Manual_after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid4=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "sq";
		$data["name"] = "Stage_Tilt_Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Cal Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0002";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid11=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Cal Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid12=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "5000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Beam_Tilt_Auto";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Cal Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "5e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid13=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual_after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Cal Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;

		$fid14=$this->mysqld->SQLInsert($table, $data);
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "RCT Focus";
		$data["SEQ|sequence"] = "[u'Z_to_Eucentric', u'Def_to_Eucentric']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid5=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "2000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Z_to_Eucentric";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "RCT Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid33=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "2000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Def_to_Eucentric";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "RCT Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid16=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Section Z Focus";
		$data["SEQ|sequence"] = "[u'Stage_Tilt_Fine', u'Stage_Tilt_High']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid6=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Section Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid17=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Tilt_High";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0349065850398866";
		$data["node name"] = "Section Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid18=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Grid Focus";
		$data["SEQ|sequence"] = "[u'Stage_Wobble_Rough']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid7=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "gr";
		$data["name"] = "Stage_Wobble_Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Grid Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid19=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Section Focus";
		$data["SEQ|sequence"] = "[u'Stage_Wobble_Rough', u'Stage_Wobble_Fine']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid8=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "sq";
		$data["name"] = "Stage_Wobble_Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Section Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid31=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage_Wobble_Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Section Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid32=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Screen Z Focus";
		$data["SEQ|sequence"] = "[u'Rough', u'Medium', u'Fine']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid9=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "sq";
		$data["name"] = "Rough";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Screen Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0002";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid22=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Medium";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Screen Z Focus";
		$data["switch"] = "0";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid23=$this->mysqld->SQLInsert($table, $data);
		
		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "2000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Screen Z Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid24=$this->mysqld->SQLInsert($table, $data);		

		$table = "AlignmentManagerSettingsData";
		$data=array();
		$data["name"] = "Align Manager";
		$data["isdefault"] = "1";
		$data["bypass"] = "0";
		$data["reset a"] = "0";
		$data["reset z"] = "0";
		$data["reset xy"] = "0";
		$data["repeat time"] = "3600";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid10=$this->mysqld->SQLInsert($table, $data);

		$table = "AcquisitionSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'hl']";
		$data["wait for rejects"] = "0";
		$data["move type"] = "stage position";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Align Parent Image";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid186=$this->mysqld->SQLInsert($table, $data);

		$table = "PhasePlateTestImagerSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'gr']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "image shift";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Check PP Low Mag";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["use parent mover"] = "1";
		$data["phase plate number"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid53=$this->mysqld->SQLInsert($table, $data);

		$table = "PhasePlateTesterSettingsData";
		$data=array();
		$data["correct image"] = "1";
		$data["SEQ|preset order"] = "[u'ep']";
		$data["wait for rejects"] = "1";
		$data["move type"] = "image shift";
		$data["save image"] = "1";
		$data["pause time"] = "10.0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["name"] = "Check PP Patches";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "one";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["use parent mover"] = "1";
		$data["phase plate number"] = "1";
		$data["total positions"] = "76";
		$data["total test positions"] = "76";
		$data["current position"] = "1";
		$data["start position"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$aid53=$this->mysqld->SQLInsert($table, $data);
		$table = "FocuserSettingsData";
		$data=array();
		$data["acquire final"] = "0";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["save image"] = "1";
		$data["pause time"] = "2.5";
		$data["melt time"] = "0";
		$data["name"] = "Align Focus";
		$data["correct image"] = "1";
		$data["wait for rejects"] = "0";
		$data["display image"] = "1";
		$data["wait for process"] = "0";
		$data["move type"] = "stage position";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["isdefault"] = "1";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0";
		$data["process target type"] = "acquisition";
		$data["melt preset"] = "fc";
		$data["save integer"] = "0";
		$data["drift between"] = "0";
		$data["final image shift"] = "0";
		$data["accept precision"] = "0.001";
		$data["wait for reference"] = "0";
		$data["adjust for transform"] = "no";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after list"] = "0";
		$data["pause between time"] = "0";
		$data["park after target"] = "0";
		$data["manual focus preset"] = "fc";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid106=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSequenceData";
		$data=array();
		$data["node name"] = "Align Focus";
		$data["SEQ|sequence"] = "[u'Stage Tilt Fine', u'Beam Tilt 1', u'Beam Tilt 2', u'Manual after']";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid74=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Stage Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Stage Z";
		$data["check drift"] = "0";
		$data["preset name"] = "hl";
		$data["name"] = "Stage Tilt Fine";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.0174532925199433";
		$data["node name"] = "Align Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.0001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid197=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "1";
		$data["preset name"] = "fa";
		$data["name"] = "Beam Tilt 1";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Align Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "5e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid198=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Beam Tilt";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fa";
		$data["name"] = "Beam Tilt 2";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Align Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "2e-05";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid199=$this->mysqld->SQLInsert($table, $data);

		$table = "FocusSettingData";
		$data=array();
		$data["correlation type"] = "phase";
		$data["fit limit"] = "1000";
		$data["focus method"] = "Manual";
		$data["stig defocus min"] = "2e-06";
		$data["drift threshold"] = "3e-10";
		$data["stig correction"] = "0";
		$data["correction type"] = "Defocus";
		$data["check drift"] = "0";
		$data["preset name"] = "fc";
		$data["name"] = "Manual after";
		$data["stig defocus max"] = "4e-06";
		$data["tilt"] = "0.01";
		$data["node name"] = "Align Focus";
		$data["switch"] = "1";
		$data["delta min"] = "0";
		$data["delta max"] = "0.001";
		$data["isdefault"] = "1";
		$data["REF|SessionData|session"]= $this->sessionId;
		$fid200=$this->mysqld->SQLInsert($table, $data);

		$table = "BeamTIltFixerSettingsData";
		$data=array();
		$data["name"] = "Align Beam Tilt";
		$data["isdefault"] = "1";
		$data["process target type"] = "acquisition";
		$data["park after list"] = "0";
		$data["pause time"] = "2.5";
		$data["pause between time"] = "0";
		$data["move type"] = "stage position";
		$data["SEQ|preset order"] = "[u'fc']";
		$data["correct image"] = "1";
		$data["display image"] = "1";
		$data["save image"] = "1";
		$data["wait for process"] = "0";
		$data["wait for rejects"] = "1";
		$data["wait for reference"] = "0";
		$data["wait time"] = "0";
		$data["iterations"] = "1";
		$data["adjust for transform"] = "one";
		$data["drift between"] = "0";
		$data["mover"] = "navigator";
		$data["move precision"] = "2e-07";
		$data["accept precision"] = "5e-07";
		$data["final image shift"] = "0";
		$data["save integer"] = "0";
		$data["background"] = "0";
		$data["use parent tilt"] = "0";
		$data["adjust time by tilt"] = "0";
		$data["reset tilt"] = "0";
		$data["bad stats response"] = "Continue";
		$data["high mean"] = "65536";
		$data["low mean"] = "50";
		$data["emission off"] = "0";
		$data["target offset row"] = "0";
		$data["target offset col"] = "0";
		$data["correct image shift coma"] = "0";
		$data["park after target"] = "0";
		$data["beam tilt"] = "0.005";
		$data["min threshold"] = "0.0002";
		$data["max threshold"] = "0.0015";
		$data["correct"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$bid20=$this->mysqld->SQLInsert($table, $data);

		$table = "ExposureFixerSettingsData";
		$data=array();
		$data["name"] = "Fix Exposure Time";
		$data["isdefault"] = "1";
		$data["move type"] = "stage position";
		$data["pause time"] = "3";
		$data["interval time"] = "3600";
		$data["override preset"] = "0";
		$data["REF|CameraSettingsData|camera settings"] = "1";
		$data["SEQ|correction presets"] = "[u'en', u'fa']";
		$data["SUBD|stage position|x"] = "0";
		$data["SUBD|stage position|y"] = "0";
		$data["SUBD|stage position|z"] = "0";
		$data["required dose"] = "20";
		$data["max exposure time"] = "1000";
		$data["REF|SessionData|session"]= $this->sessionId;
		$eid20=$this->mysqld->SQLInsert($table, $data);

		$table = "AlignZLPSettingsData";
		$data=array();
		$data["name"] = "Align ZLP";
		$data["isdefault"] = "1";
		$data["bypass"] = "1";
		$data["move type"] = "stage position";
		$data["pause time"] = "3";
		$data["interval time"] = "3600";
		$data["return settle time"] = "30";
		$data["mover"] = "presets manager";
		$data["move precision"] = "0.0000005";
		$data["accept precision"] = "0.000001";
		$data["check preset"] = "fa";
		$data["threshold"] = "0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$eid20=$this->mysqld->SQLInsert($table, $data);

		$table = "AutoFillerSettingsData";
		$data=array();
		$data["name"] = "N2 Filling";
		$data["isdefault"] = "1";
		$data["bypass"] = "1";
		$data["repeat time"] = "1200";
		$data["autofiller mode"] = "both cold";
		$data["column fill start"] = "45";
		$data["column fill end"] = "70";
		$data["loader fill start"] = "17";
		$data["loader fill end"] = "70";
		$data["REF|SessionData|session"]= $this->sessionId;
		$eid20=$this->mysqld->SQLInsert($table, $data);

		$table = "BufferCyclerSettingsData";
		$data=array();
		$data["name"] = "Buffer Cycling";
		$data["isdefault"] = "1";
		$data["bypass"] = "1";
		$data["repeat time"] = "1200";
		$data["trip value"] = "80.0";
		$data["REF|SessionData|session"]= $this->sessionId;
		$eid20=$this->mysqld->SQLInsert($table, $data);
	}
			
}


?>
